% Lezione di lab  TTR  -17/05/2017- Tracking by Condensation- Marco Cristani

clear all;
clc;

%----------------------
% INIZIALIZZAZIONI
%----------------------

N       = 500 ; % numero particelle;
n_it    = 50   ; % iterazioni (= frames) del tracking;
loc_w   = 200   ; % larghezza della finestra d'osservazione;
dvst    = loc_w/3; % dev. standard per l'osservazione;

%% -- PARAMETRI MOTO -- %%
p_step        = 0.4  ;   % passo deterministico oggetto
p_noise       = 0.075 ;  


%% -- PARAMETRI MODELLO DINAMICO -- %%
diffu = 200; 
step = 0.2; % passo deterministico modello dinamica

%% -- PRIMO SAMPLING -- %%
real_pos               = 0.0; % POsizione reale dell'oggetto all'istante 1


for n=1:N
   s_old(n)            =  unifrnd(real_pos -3,real_pos +3) ;
end;  
pi = ones(1,N)./N; 
c = cumsum(pi);



 h = figure;
%----------------------
% CICLO PRINCIPALE
%----------------------

%% -- EVOLUZIONE SISTEMA -- %%
for i=1:n_it
    
%      real_pos    =   real_pos + p_step + p_noise * randn(1,1); % moto unif. + noise
    real_pos    =   real_pos + 0.05*i^2 + p_step + p_noise * randn(1,1); % moto accelerato
%    real_pos    =   real_pos + 2*sin(i/2) + p_noise * randn(1,1); % moto sinus.

    x(i)        =   real_pos;
    fprintf('t=%i|true pos. %2.2f \n',i,x(i));
    sit(i).oneD =  [x(i),...
        unifrnd(real_pos-10,real_pos+10,1,round(unifrnd(1,5))),...
        normrnd(real_pos,0.01,1,3)];

%% -- ESTRAZIONE E APPLICAZIONE DINAMICA -- %%
 for n=1:N
      ind     = pick_base_sample(N,c);
      s(n)     = s_old(ind) + step + diffu * randn(1,1);
 end   

 scatter(i,real_pos,500,[1 0 0],'Marker','x');hold on 
 scatter(ones(1,size(sit(i).oneD,2)).*i,sit(i).oneD,10,[1 0 0],'Marker','o');
 
 %% -- VALUTAZIONE DELL'OSSERVAZIONE -- %%
 for n=1:N
     mpi(n) = 0;
     for j =1:size(sit(i).oneD,2)
         if s(n)+loc_w>sit(i).oneD(j) & s(n)-loc_w<sit(i).oneD(j)
            mpi(n)= mpi(n)+normpdf(sit(i).oneD(j),s(n),dvst);
         end
     end
 end   
 s_old = s;
 mpi = normalise(mpi);
 c = cumsum(mpi);
 
 scatter(ones(1,N).*i,s,2000.*mpi+1,'bo');
 
 %% Determinazione della posizione del target stimata da Condensation
 % Media
 pos_mean(i)= s*mpi'/N;
 err_mean(i)= abs(x(i)-pos_mean(i));
 fprintf('Err media:%i \n\n',err_mean(i));
 % Max
 [thrash,max_ind]= max(mpi);
 pos_max(i)=s(max_ind);
 err_max(i)= abs(x(i)-pos_max(i));
  fprintf('Err MAP:%i \n\n',err_max(i));

 
 
 pause(0.1);
end

% Exercise 1
% Understand the code, linking it to the theory. 

% Exercise 2
% Look what target estimation works the best: mean or max? Why?

% Exercise 3
% Change the parameters of the tracker, in particular:
% a) the number of particles
% b) the number of noise elements
% c) the observation window size
% d) the motion of the real object (sinusoid, uniformly accelerated, etc.)


% Exercise 4
% try to let the tracking recover the error for this motion of the real
% object:  
% real_pos    =   real_pos + 0.05*i^2 + p_step + p_noise * randn(1,1); 
% WITHOUT SIMPLY PLUGGING IN THIS MOTION INTO THE TRACKER


% Exercise 5
% A practical question: why I should do tracking, instead of doing an
% exhaustive search of my target, using for example normalized cross
% correlation?



% Exercise 5
% Put a 2D point into play, and track it: everything has to be put into 2D
% (noise, particles, motion dynamics etc.)





% Exercise 6
% Use your video to do the tracking



